|  | Home · All Classes · Main Classes · Grouped Classes · Modules · Functions |

# MediaNode Class Reference
(Phonon::MediaNode)
[Phonon module]

The MediaNode class is the base class for all nodes in a media graph. More...

     #include <Phonon>

This class was introduced in Qt 4.4.

- List of all members, including inherited members

### Public Functions

- virtual ~MediaNode ()
- QList<Path> inputPaths () const
- bool isValid () const
- QList<Path> outputPaths () const

## Detailed Description

The MediaNode class is the base class for all nodes in a media graph.

In all phonon applications, one builds a media graph consisting of MediaNodes. The graph will take multimedia content, e.g., from a file, as input. After its nodes have processed the multimedia, the graph will output the media again, e.g., to a sound card.

The multimedia content is streamed over Paths between the nodes in the graph. You can query the paths that are connected to a media node with inputPaths() and outputPaths().

You can check whether the node is implemented by the current backend by calling isValid(). This does not guarantee that an instance of the class works as expected, but that the backend has implemented functionality for the class.

Currently, Phonon has three media nodes: MediaObject, AudioOutput, and VideoWidget. Please refer to their class descriptions for details about their usage, and to find out which nodes can be connected to each other. See also Building Graphs in Phonon's overview document.

Two nodes are connected to each other using the Phonon::createPath() function. We show a code example below, in which we build a media graph for video playback and then query its media nodes for their Paths:

When you create a Phonon application, you will likely build the graph yourself. This makes isValid() the most useful function of this class. The other two functions help navigate the graph, which you do not need to do as you created the nodes yourself.

See also Phonon Overview, Phonon::MediaObject, Phonon::AudioOutput, and Phonon::VideoWidget.

## Member Function Documentation

### MediaNode::~MediaNode () `[virtual]`

Destroys the media node and any paths connecting it to other nodes.

### QList<Path> MediaNode::inputPaths () const

Returns the paths that inputs multimedia to this media node.

See also outputPaths().

### bool MediaNode::isValid () const

Returns true if the backend provides an implementation of this class; otherwise returns false.

This does not guarantee that instances of the class works as expected, but that the backend has implemented the functionality for this class. For instance, Qt's GStreamer backend will return true for instances of the AudioOutput class, even if there is a problem with GStreamer and it could not play sound.

### QList<Path> MediaNode::outputPaths () const

Returns the paths to which this media node output media.

See also inputPaths().